diff mbox

[2/2] qemu-iotests: Test progress output for conversion

Message ID 1393855031-26915-3-git-send-email-kwolf@redhat.com
State New
Headers show

Commit Message

Kevin Wolf March 3, 2014, 1:57 p.m. UTC
Signed-off-by: Kevin Wolf <kwolf@redhat.com>
---
 tests/qemu-iotests/086     | 65 ++++++++++++++++++++++++++++++++++++++++++++++
 tests/qemu-iotests/086.out | 18 +++++++++++++
 tests/qemu-iotests/group   |  1 +
 3 files changed, 84 insertions(+)
 create mode 100755 tests/qemu-iotests/086
 create mode 100644 tests/qemu-iotests/086.out

Comments

Eric Blake March 3, 2014, 6:20 p.m. UTC | #1
On 03/03/2014 06:57 AM, Kevin Wolf wrote:
> Signed-off-by: Kevin Wolf <kwolf@redhat.com>
> ---
>  tests/qemu-iotests/086     | 65 ++++++++++++++++++++++++++++++++++++++++++++++
>  tests/qemu-iotests/086.out | 18 +++++++++++++
>  tests/qemu-iotests/group   |  1 +
>  3 files changed, 84 insertions(+)
>  create mode 100755 tests/qemu-iotests/086
>  create mode 100644 tests/qemu-iotests/086.out
> 

> +
> +$QEMU_IMG convert -p -O $IMGFMT -f $IMGFMT "$TEST_IMG" "$TEST_IMG".base  2>&1 |\
> +    _filter_testdir | sed -e 's/\r/\n/g'

\r is not portable sed.  Alas, coming up with a portable way to
represent carriage return in sed is a bear, so I can live with this
reliance on GNU sed.


> +wrote 1048576/1048576 bytes at offset 33554432
> +1 MiB, X ops; XX:XX:XX.X (XXX YYY/sec and XXX ops/sec)
> +    (0.00/100%)
> +    (25.00/100%)
> +    (50.00/100%)
> +    (75.00/100%)
> +    (100.00/100%)
> +    (100.00/100%)

Feels fragile (will it ALWAYS be done in chunks of 25% completion?) but
if it passes reliably, it's always better to have more test coverage.
Can we test the other commands that support -p?  And is anyone
interested in adding -p support to more commands (there are several
long-running commands that could use it but don't have it yet).
Kevin Wolf March 4, 2014, 9:02 a.m. UTC | #2
Am 03.03.2014 um 19:20 hat Eric Blake geschrieben:
> On 03/03/2014 06:57 AM, Kevin Wolf wrote:
> > Signed-off-by: Kevin Wolf <kwolf@redhat.com>
> > ---
> >  tests/qemu-iotests/086     | 65 ++++++++++++++++++++++++++++++++++++++++++++++
> >  tests/qemu-iotests/086.out | 18 +++++++++++++
> >  tests/qemu-iotests/group   |  1 +
> >  3 files changed, 84 insertions(+)
> >  create mode 100755 tests/qemu-iotests/086
> >  create mode 100644 tests/qemu-iotests/086.out
> > 
> 
> > +
> > +$QEMU_IMG convert -p -O $IMGFMT -f $IMGFMT "$TEST_IMG" "$TEST_IMG".base  2>&1 |\
> > +    _filter_testdir | sed -e 's/\r/\n/g'
> 
> \r is not portable sed.  Alas, coming up with a portable way to
> represent carriage return in sed is a bear, so I can live with this
> reliance on GNU sed.

We already have it in other places, so I guess this one doesn't make
things worse.

> > +wrote 1048576/1048576 bytes at offset 33554432
> > +1 MiB, X ops; XX:XX:XX.X (XXX YYY/sec and XXX ops/sec)
> > +    (0.00/100%)
> > +    (25.00/100%)
> > +    (50.00/100%)
> > +    (75.00/100%)
> > +    (100.00/100%)
> > +    (100.00/100%)
> 
> Feels fragile (will it ALWAYS be done in chunks of 25% completion?) but
> if it passes reliably, it's always better to have more test coverage.

Yes, this concern is what stopped me from writing such a test for a long
time. However, I think we really need a test case for it because
apparently we tend to break this, and after some pondering I came to the
conclusion that results should be consistent as long as we restrict it
to a single image format (drivers may behave differently), which is not
raw (that would expose filesystem-specific behaviour).

With a qcow2-only case I think we should be fine as long as neither
qcow2 nor qemu-img change their implementation.

The other case that I would love to test is not specifying -p but
sending SIGUSR1. I'm not sure how to do that in a consistent way,
though. Perhaps something with blkdebug.

> Can we test the other commands that support -p?  And is anyone
> interested in adding -p support to more commands (there are several
> long-running commands that could use it but don't have it yet).

Feel free to implement it. ;-)

(Perhaps it would be easier after converting some qemu-img subcommands
to use block jobs internally.)

Kevin
diff mbox

Patch

diff --git a/tests/qemu-iotests/086 b/tests/qemu-iotests/086
new file mode 100755
index 0000000..48fe85b
--- /dev/null
+++ b/tests/qemu-iotests/086
@@ -0,0 +1,65 @@ 
+#!/bin/bash
+#
+# Test qemu-img progress output
+#
+# Copyright (C) 2014 Red Hat, Inc.
+#
+# This program is free software; you can redistribute it and/or modify
+# it under the terms of the GNU General Public License as published by
+# the Free Software Foundation; either version 2 of the License, or
+# (at your option) any later version.
+#
+# This program is distributed in the hope that it will be useful,
+# but WITHOUT ANY WARRANTY; without even the implied warranty of
+# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+# GNU General Public License for more details.
+#
+# You should have received a copy of the GNU General Public License
+# along with this program.  If not, see <http://www.gnu.org/licenses/>.
+#
+
+# creator
+owner=kwolf@redhat.com
+
+seq=`basename $0`
+echo "QA output created by $seq"
+
+here=`pwd`
+tmp=/tmp/$$
+status=1	# failure is the default!
+
+_cleanup()
+{
+	_cleanup_test_img
+}
+trap "_cleanup; exit \$status" 0 1 2 3 15
+
+# get standard environment, filters and checks
+. ./common.rc
+. ./common.filter
+
+_supported_fmt qcow2
+_supported_proto file
+_supported_os Linux
+
+function run_qemu_img()
+{
+    echo
+    echo Testing: "$@" | _filter_testdir
+}
+
+size=128M
+
+_make_test_img $size
+$QEMU_IO -c 'write 0 1M' $TEST_IMG | _filter_qemu_io
+$QEMU_IO -c 'write 2M 1M' $TEST_IMG | _filter_qemu_io
+$QEMU_IO -c 'write 4M 1M' $TEST_IMG | _filter_qemu_io
+$QEMU_IO -c 'write 32M 1M' $TEST_IMG | _filter_qemu_io
+
+$QEMU_IMG convert -p -O $IMGFMT -f $IMGFMT "$TEST_IMG" "$TEST_IMG".base  2>&1 |\
+    _filter_testdir | sed -e 's/\r/\n/g'
+
+# success, all done
+echo "*** done"
+rm -f $seq.full
+status=0
diff --git a/tests/qemu-iotests/086.out b/tests/qemu-iotests/086.out
new file mode 100644
index 0000000..9c0bf23
--- /dev/null
+++ b/tests/qemu-iotests/086.out
@@ -0,0 +1,18 @@ 
+QA output created by 086
+Formatting 'TEST_DIR/t.IMGFMT', fmt=IMGFMT size=134217728 
+wrote 1048576/1048576 bytes at offset 0
+1 MiB, X ops; XX:XX:XX.X (XXX YYY/sec and XXX ops/sec)
+wrote 1048576/1048576 bytes at offset 2097152
+1 MiB, X ops; XX:XX:XX.X (XXX YYY/sec and XXX ops/sec)
+wrote 1048576/1048576 bytes at offset 4194304
+1 MiB, X ops; XX:XX:XX.X (XXX YYY/sec and XXX ops/sec)
+wrote 1048576/1048576 bytes at offset 33554432
+1 MiB, X ops; XX:XX:XX.X (XXX YYY/sec and XXX ops/sec)
+    (0.00/100%)
+    (25.00/100%)
+    (50.00/100%)
+    (75.00/100%)
+    (100.00/100%)
+    (100.00/100%)
+
+*** done
diff --git a/tests/qemu-iotests/group b/tests/qemu-iotests/group
index db127d9..1084bfc 100644
--- a/tests/qemu-iotests/group
+++ b/tests/qemu-iotests/group
@@ -85,3 +85,4 @@ 
 079 rw auto
 081 rw auto
 082 rw auto quick
+086 rw auto quick